<?php
class hikashopUserClass extends hikashopClass{
	var $tables = array('user');
	var $pkeys = array('user_id');
	
	function get($id,$type='hikashop',$geoloc=false){
		static $data = array();
		if($id===false){
			//reset cache
			$data = array();
			return true;
		}
		if(empty($data[$type.'_'.$id])){
			$field = 'user_id';
			switch($type){
				case 'hikashop':
					$field = 'user_id';
					$id = (int)$id;
					break;
				case 'email':
					$field = 'user_email';
					$id = $this->database->Quote(trim($id));
					break;
				case 'cms':
				default:
					$field = 'user_cms_id';
					$id = (int)$id;
					break;
			}
			$geo='';
			$select='a.*,b.*';
			if($geoloc && hikashop::level(2)){
				$geo=' LEFT JOIN '.hikashop::table('geolocation').' AS c ON a.user_id=c.geolocation_ref_id AND c.geolocation_type=\'user\'';
				$select.=',c.*';
			}
			
			$query = 'SELECT '.$select.' FROM '.hikashop::table('user').' AS a LEFT JOIN '.hikashop::table('users',false).' AS b ON a.user_cms_id=b.id '.$geo.' WHERE a.'.$field.'='.$id;
			$this->database->setQuery($query);
			$user = $this->database->loadObject();
			if(!empty($user->user_params)){
				$user->user_params = unserialize($user->user_params);
			}
			$data[$type.'_'.$id] = $user;
		}
		return $data[$type.'_'.$id];
	}
	function getID($cms_id,$type='cms'){
		$user = $this->get($cms_id,$type);
		$id = (int)@$user->user_id;
		
		if(empty($id)&&$type=='cms'){
			$userData =& JFactory::getUser($cms_id);
			if(!empty($userData)){
				$user = null;
				$user->user_cms_id = $cms_id;
				$user->user_email = $userData->email;
				$id = $this->save($user);
			}
			
		}
		
		return $id;
	}
	
	function save(&$element,$skipJoomla=false){
		$new = true;
		if(!empty($element->user_id)){
			$new = false;
		}else{
			if(empty($element->user_created_ip)){
				$element->user_created_ip = hikashop::getIP();
			}
			if(empty($element->user_email)&&!empty($element->user_cms_id)){
				$user =& JFactory::getUser($element->user_cms_id);
				$element->user_email = $user->email;
			}elseif(!empty($element->user_email)&&empty($element->user_cms_id)){
				//TODO try to fill the id from the email
			}
		}
		
		if(isset($element->user_currency_id)){
			$user = $this->get($element->user_id);
			$config =& hikashop::config();
			if(empty($user->user_currency_id)){
				$user->user_currency_id = $config->get('partner_currency');
			}
			$previousPartnerCurrency = $user->user_currency_id;
			$app =& JFactory::getApplication();
			if($app->isAdmin()){
				if($element->user_currency_id == $config->get('partner_currency')){
					$element->user_currency_id=0;
					//$previousPartnerCurrency=0;
				}
			}else{
				if($config->get('allow_currency_selection')){
					//check that the user has the right to set a currency (to avoid possible hacks)
					$currencyClass = hikashop::get('class.currency');
					$currency = $currencyClass->get($element->user_currency_id);
					if(empty($currency->currency_published)){
						unset($element->user_currency_id);
					}
				}else{
					unset($element->user_currency_id);
				}
			}
			if(!empty($element->user_currency_id)) $element->user_currency_id=(int)$element->user_currency_id;
		}
			
		if(!empty($element->user_params)){
			$element->user_params = serialize($element->user_params);
		}
		$element->user_id = parent::save($element);
		if(!empty($element->user_id)){
			if($element->user_id==hikashop::loadUser()){
				hikashop::loadUser(null,true);
				$this->get(false);
			}
			if($new){
				$plugin =& JPluginHelper::getPlugin('hikashop', 'geolocation');
				if(!empty($plugin) && hikashop::level(1)){
					jimport('joomla.html.parameter');
					$params = new JParameter( $plugin->params );
					if(!empty($params)){
						if($params->get('user',1)){
				    		$geo = null;
				    		$geo->geolocation_ref_id = $element->user_id;
				    		$geo->geolocation_type = 'user';
				    		$geo->geolocation_ip = $element->user_created_ip;
				    		$class = hikashop::get('class.geolocation');
				    		$class->params =& $params;
				    		$class->save($geo);
			    		}
					}
				}
			}else{
				if(!$skipJoomla && !empty($element->user_email)){
					if(empty($element->user_cms_id)){
						$userData = $this->get($element->user_id);
						$element->user_cms_id = $userData->user_cms_id;
					}
					$user =& JFactory::getUser($element->user_cms_id);
					if(!empty($user) && $element->user_email!=$user->email){
						//update joomla's user email if there was a modification
						$user->email = $element->user_email;
						$user->save();
					}
				}
				if(isset($element->user_currency_id)){
					if(empty($element->user_currency_id)){
						$element->user_currency_id = $config->get('partner_currency');
					}
					if($element->user_currency_id!=$previousPartnerCurrency){
						//convert partner's not already paid earnings into the new currency
						$currencyClass = hikashop::get('class.currency');
						$config =& hikashop::config();
						$null=null;
						$main_currency = (int)$config->get('main_currency',1);
						$ids = array();
						$ids[$previousPartnerCurrency]=$previousPartnerCurrency;
						$ids[$element->user_currency_id]=$element->user_currency_id;
						$ids[$main_currency]=$main_currency;
						$currencies=$currencyClass->getCurrencies($ids,$null);
						$srcCurrency = $currencies[$previousPartnerCurrency];
						$dstCurrency = $currencies[$element->user_currency_id];
						$mainCurrency =  $currencies[$main_currency];
						$this->_updatePartnerPrice($srcCurrency,$dstCurrency,$mainCurrency,$element,$previousPartnerCurrency,'click');
						$this->_updatePartnerPrice($srcCurrency,$dstCurrency,$mainCurrency,$element,$previousPartnerCurrency,'order');
						$this->_updatePartnerPrice($srcCurrency,$dstCurrency,$mainCurrency,$element,$previousPartnerCurrency,'user');
					}
				}
			}
		}
		return $element->user_id;
	}
	
	function _updatePartnerPrice(&$srcCurrency,&$dstCurrency,&$mainCurrency,&$element,$previousPartnerCurrency,$type='click'){
		$amount='';
		if($srcCurrency->currency_id!=$mainCurrency->currency_id){
			$amount=$type.'_partner_price/'.floatval($srcCurrency->currency_rate);
			$amount=$amount.'+'.$amount.'*'.floatval($srcCurrency->currency_percent_fee);
			if($dstCurrency->currency_id!=$mainCurrency->currency_id){
				$amount = '('.$amount.')/'.floatval($dstCurrency->currency_rate);
				$amount=$amount.'+'.$amount.'*'.floatval($dstCurrency->currency_percent_fee);
			}
		}elseif($dstCurrency->currency_id!=$mainCurrency->currency_id){
			$amount=$type.'_partner_price/'.floatval($dstCurrency->currency_rate);
			$amount=$amount.'+'.$amount.'*'.floatval($dstCurrency->currency_percent_fee);
		}
		if(!empty($amount)){
			$amount = ','.$type.'_partner_price='.$amount;
		}
		$query = 'UPDATE '.hikashop::table($type).' SET '.$type.'_partner_currency_id='.$element->user_currency_id.$amount.' WHERE '.$type.'_partner_id='.$element->user_id.' AND '.$type.'_partner_paid=0 AND '.$type.'_partner_currency_id='.$previousPartnerCurrency;
		$this->database->setQuery($query);
		$this->database->query();
	}
	
	function saveForm(){
		$fieldsClass = hikashop::get('class.field');
		$element = $fieldsClass->getInput('user');
		if(empty($element)){
			return false;
		}
		$element->user_id = hikashop::getCID('user_id');
		
		$status = $this->save($element);
		if($status){
			//reset user info in cache
			hikashop::loadUser(null,true);
			$this->get(false);
		}
		return $status;
	}
	
	function delete(&$elements){
		$result = true;
		if(!empty($elements)){
			if(!is_array($elements)){
				$elements = array((int)$elements);
			}else{
				JArrayHelper::toInteger($elements);
			}
			foreach($elements as $el){
				$query = 'SELECT count(*) FROM '.hikashop::table('order').' WHERE order_user_id='.$el;
				$this->database->setQuery($query);
				$hasOrders = $this->database->loadResult();
				if(empty($hasOrders)){
					$result = parent::delete($el);
				}else{
					$app =& JFactory::getApplication();
					if($app->isAdmin()){
						$data = $this->get($el);
						$app->enqueueMessage('The user with the email address "'.$data->user_email.'" could not be deleted in HikaShop because he has orders attached to him. If you want to delete this user in HikaShop as well, you first need to delete his orders.');
					}
					$query = 'UPDATE '.hikashop::table('user').' SET user_cms_id=0 WHERE user_id IN ('.implode(',',$elements).')';
					$this->database->setQuery($query);
					$result = $this->database->query();
				}
			}
		}
		return $result;
	}
	
	function loadPartnerData(&$user){
		if(empty($user->user_params->user_custom_fee)){
			$config=&hikashop::config();
			$user->user_params->user_partner_click_fee = $config->get('partner_click_fee',0);
			$user->user_params->user_partner_lead_fee = $config->get('partner_lead_fee',0);
			$user->user_params->user_partner_percent_fee = $config->get('partner_percent_fee',0);
			$user->user_params->user_partner_flat_fee = $config->get('partner_flat_fee',0);
			$user->user_params->user_currency_id = $config->get('user_currency_id',1);
		}

		$user->accumulated=array();
		$db =& JFactory::getDBO();
		if(!empty($user->user_partner_activated)){
			//load partner stats
			
			//load clicks if necessary
			$user->accumulated['clicks']=0;
			if(bccomp($user->user_params->user_partner_click_fee,0,5)){
				$query='SELECT SUM(click_partner_price) AS clicks_total FROM '.hikashop::table('click').' WHERE click_partner_id='.$user->user_id.' AND click_partner_paid=0 GROUP BY click_partner_id';
				$db->setQuery($query);
				$user->accumulated['clicks']=$db->loadResult()*1;
			}
			//load leads if necessary
			$user->accumulated['leads']=0;
			if(bccomp($user->user_params->user_partner_lead_fee,0,5)){
				$query='SELECT SUM(user_partner_price) AS leads_total FROM '.hikashop::table('user').' WHERE user_partner_id='.$user->user_id.' AND user_partner_paid=0 GROUP BY user_partner_id';
				$db->setQuery($query);
				$user->accumulated['leads']=$db->loadResult()*1;
			}
			
			//load sales if necessary
			$user->accumulated['sales']=0;
			if(bccomp($user->user_params->user_partner_percent_fee,0,5) || bccomp($user->user_params->user_partner_flat_fee,0,5)){
				$config =& hikashop::config();
				$partner_valid_status_list=explode(',',$config->get('partner_valid_status','confirmed,shipped'));
				foreach($partner_valid_status_list as $k => $partner_valid_status){
					$partner_valid_status_list[$k]= $this->database->Quote($partner_valid_status);
				}
				$query='SELECT SUM(order_partner_price) AS sales_total FROM '.hikashop::table('order').' WHERE order_partner_id='.$user->user_id.' AND order_type=\'sale\' AND order_partner_paid=0 AND order_status IN ('.implode(',',$partner_valid_status_list).') GROUP BY order_partner_id';
				$db->setQuery($query);
				$user->accumulated['sales']=$db->loadResult()*1;
			}
			$user->accumulated['total'] = round($user->accumulated['sales'] + $user->accumulated['leads'] + $user->accumulated['clicks'],2);
		}
		
	}
	
	function loadSales(&$user,$base){
		if(empty($user->user_params->user_custom_fee)){
			$config=&hikashop::config();
			$user->user_params->user_partner_percent_fee = $config->get('partner_percent_fee',0);
			$user->user_params->user_partner_flat_fee = $config->get('partner_flat_fee',0);
		}
		$user->sales = array();
		if(!empty($user->user_partner_activated)){
			if(bccomp($user->user_params->user_partner_percent_fee,0,5) || bccomp($user->user_params->user_partner_flat_fee,0,5)){
				$config =& hikashop::config();
				$partner_valid_status_list=explode(',',$config->get('partner_valid_status','confirmed,shipped'));
				foreach($partner_valid_status_list as $k => $partner_valid_status){
					$partner_valid_status_list[$k]= $this->database->Quote($partner_valid_status);
				}
				$query='SELECT * FROM '.hikashop::table('order').' WHERE order_partner_id='.$user->user_id.' AND order_type=\'sale\' AND order_partner_paid=0 AND order_status IN ('.implode(',',$partner_valid_status_list).') ORDER BY order_created DESC';
				$db->setQuery($query);
				$user->sales = $db->loadObjectList();
			}
		}
	}
	
	function loadClicks(&$user,$base){
		if(empty($user->user_params->user_custom_fee)){
			$config=&hikashop::config();
			$user->user_params->user_partner_click_fee = $config->get('partner_click_fee',0);
		}
		$user->clicks = array();
		if(!empty($user->user_partner_activated)){
			if(bccomp($user->user_params->user_partner_click_fee,0,5)){
				$query='SELECT * FROM '.hikashop::table('click').' WHERE click_partner_id='.$user->user_id.' AND click_partner_paid=0 ORDER BY click_created DESC';
				$db->setQuery($query);
				$user->clicks = $db->loadObjectList();
			}
		}
	}
	
	function loadLeads(&$user,$base){
		if(empty($user->user_params->user_custom_fee)){
			$config=&hikashop::config();
			$user->user_params->user_partner_lead_fee = $config->get('partner_lead_fee',0);
		}
		$user->leads = array();
		if(!empty($user->user_partner_activated)){
			if(bccomp($user->user_params->user_partner_lead_fee,0,5)){
				$query='SELECT * FROM '.hikashop::table('user').' WHERE user_partner_id='.$user->user_id.' AND user_partner_paid=0 ORDER BY user_id DESC';
				$db->setQuery($query);
				$user->leads = $db->loadObjectList();
			}
		}
	}
	
	function getLatest($partner_id,$ip,$lead_min_delay){
		$query = 'SELECT user_id FROM '.hikashop::table('user').' WHERE user_partner_id='.(int)$partner_id.' AND user_created_ip='.$this->database->Quote($ip).' AND click_created > '.(time()-$lead_min_delay*3600);
		$this->database->setQuery($query);
		return $this->database->loadResult();
	}
}